# (oe) undefining these makes the build _real_ quick.
%undefine __find_provides
%undefine __find_requires

%define rname	phpLDAPAdmin

Summary:	A web-based LDAP administration tool
Name:		phpldapadmin
Version:	1.1.0.7
Release:	%mkrel 3
License:	GPLv2+
Group:		System/Servers
URL:		http://phpldapadmin.sourceforge.net/
Source0:	http://prdownloads.sourceforge.net/phpldapadmin/%{name}-%{version}.tar.gz
Source1:	mandrivaDSPerson.xml
Patch0:		phpldapadmin-1.1.0.5-config.diff
Patch1:		phpldapadmin-1.1.0.7-php53.patch
Patch2:		phpldapadmin-1.1.0.7-security-cmd.patch
# 		Remove the php53 patch when this package is updated to 1.2.x.x versions of phpldapadmin. 
# 		Patch1 for bug: #54261.  
Requires(pre):	apache-mod_php php-ldap php-xml php-mcrypt php-gettext
Requires:	apache-mod_php
Requires:	php-ldap >= 5.3.1 
Requires:	php-xml php-mcrypt php-gettext
Requires(post):	ccp >= 0.4.0
BuildRequires:	apache-base >= 2.0.54
BuildRequires:	ImageMagick
BuildArch:	noarch
Obsoletes:	phpLDAPAdmin
Conflicts:	phpLDAPAdmin
BuildRoot:	%{_tmppath}/%{name}-buildroot

# Macro for generating an environment variable (%1) with %2 random characters
%define randstr() %1=`perl -e 'for ($i = 0, $bit = "!", $key = ""; $i < %2; $i++) {while ($bit !~ /^[0-9A-Za-z]$/) { $bit = chr(rand(90) + 32); } $key .= $bit; $bit = "!"; } print "$key";'`

%description
phpldapadmin is a web-based LDAP administration tool, written in PHP. You can
browse your LDAP tree, create, delete, edit, and copy entries, perform
searches, and view your server's schema. You can even copy objects between two
LDAP servers and recursively delete or copy entire trees. All this from the
comfort of your web browser.

On the server it is installed on, this should be accessible at
http://localhost/%{name}

%prep

%setup -q -n %{name}-%{version}
%patch0 -p1
%patch1 -p1
%patch2 -p1

cp %{SOURCE1} templates/creation/

# fix dir perms
find . -type d | xargs chmod 755

# fix file perms
find . -type f | xargs chmod 644

%build

%install
rm -rf %{buildroot}

install -d %{buildroot}/var/www/%{name}
install -d %{buildroot}%{_sysconfdir}/httpd/conf/webapps.d
install -d %{buildroot}%{_sysconfdir}/%{name}
install -d %{buildroot}/var/lib/%{name}

cp -aRf * %{buildroot}/var/www/%{name}/

mv %{buildroot}/var/www/%{name}/config/config.php.example %{buildroot}%{_sysconfdir}/%{name}/config.php
rm -rf %{buildroot}/var/www/%{name}/config %{buildroot}/var/www/%{name}/tools/po

rm -f %{buildroot}/var/www/%{name}/{INSTALL,LICENSE,config.php.example}
rm -Rf %{buildroot}/var/www/%{name}/doc

cat > %{buildroot}%{_sysconfdir}/httpd/conf/webapps.d/%{name}.conf << EOF

Alias /%{name} /var/www/%{name}

<Directory "/var/www/%{name}">
    Order deny,allow
    Deny from all
    Allow from 127.0.0.1
    ErrorDocument 403 "Access denied per %{_sysconfdir}/httpd/conf/webapps.d/%{name}.conf"
</Directory>

# Uncomment the following lines to force a redirect to a working
# SSL aware apache server. This serves as an example.
#
#<IfModule mod_ssl.c>
#    <LocationMatch /%{name}>
#        Options FollowSymLinks
#        RewriteEngine on
#        RewriteCond %{SERVER_PORT} !^443$
#        RewriteRule ^.*$ https://%{SERVER_NAME}%{REQUEST_URI} [L,R]
#    </LocationMatch>
#</IfModule>

EOF

# Mandriva Icons
install -d %{buildroot}%{_iconsdir}
install -d %{buildroot}%{_miconsdir}
install -d %{buildroot}%{_liconsdir}

convert htdocs/images/logo.png -resize 16x16 %{buildroot}%{_miconsdir}/%{name}.png
convert htdocs/images/logo.png -resize 32x32 %{buildroot}%{_iconsdir}/%{name}.png
convert htdocs/images/logo.png -resize 48x48 %{buildroot}%{_liconsdir}/%{name}.png

# install menu entry.

# XDG menu
install -d %{buildroot}%{_datadir}/applications
cat > %{buildroot}%{_datadir}/applications/mandriva-%{name}.desktop << EOF
[Desktop Entry]
Name=%{rname}
Comment=%{rname} is a web adminstration GUI for OpenLDAP
Exec=%{_bindir}/www-browser http://localhost/%{name}/
Icon=%{name}
Terminal=false
Type=Application
Categories=X-MandrivaLinux-MoreApplications-Databases;
EOF

# cleanup
rm -rf doc/certs

%post
ccp --delete --ifexists --set "NoOrphans" --ignoreopt config_version --oldfile %{_sysconfdir}/%{name}/config.php --newfile %{_sysconfdir}/%{name}/config.php.rpmnew

%randstr BLOWFISH 8

BLOWFISH=`echo -n $BLOWFISH | md5sum | awk '{print $1}'`
perl -pi -e "s|_BLOWFISH_SECRET_|$BLOWFISH|g" %{_sysconfdir}/%{name}/config.php

%_post_webapp
%if %mdkversion < 200900
%update_menus
%endif

%postun
%_postun_webapp
%if %mdkversion < 200900
%clean_menus
%endif

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc doc/*
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/httpd/conf/webapps.d/%{name}.conf
%attr(0755,root,root) %dir %{_sysconfdir}/%{name}
%attr(0640,apache,root) %config(noreplace) %{_sysconfdir}/%{name}/config.php
/var/www/%{name}
%attr(0755,apache,apache) %dir /var/lib/%{name}
%{_iconsdir}/%{name}.png
%{_miconsdir}/%{name}.png
%{_liconsdir}/%{name}.png
%{_datadir}/applications/*.desktop


%changelog
* Wed Dec 30 2009 Glen Ogilvie <nelg@mandriva.org> 1.1.0.7-3mdv2010.0
+ Revision: 483942
- patches to fix #56719 (bug) and #56720 (security problem with cmd.php)
- patch fixes bug: 54261
  added patch for php 5.3.  This hides some errors and changes the code to fix other errors.

* Tue May 19 2009 Glen Ogilvie <nelg@mandriva.org> 1.1.0.7-1mdv2010.0
+ Revision: 377528
- New release: 1.1.0.7, fixing a few minor bugs. Also, a minor improvement to mandrivaDSPerson template, making gidNumber a dropdown list

* Tue Jan 20 2009 Jérôme Soyer <saispo@mandriva.org> 1.1.0.6-1mdv2009.1
+ Revision: 331574
- Add patch for Boost

* Fri Jul 04 2008 Oden Eriksson <oeriksson@mandriva.com> 1.1.0.5-3mdv2009.0
+ Revision: 231663
- hardcode %%{_localstatedir}
- don't package the certs

  + Pixel <pixel@mandriva.com>
    - rpm filetriggers deprecates update_menus/update_scrollkeeper/update_mime_database/update_icon_cache/update_desktop_database/post_install_gconf_schemas
    - adapt to %%_localstatedir now being /var instead of /var/lib (#22312)

* Sat May 31 2008 Oden Eriksson <oeriksson@mandriva.com> 1.1.0.5-2mdv2009.0
+ Revision: 213592
- added S1 to support the Mandriva Directory Server

* Wed Feb 06 2008 Guillaume Rousse <guillomovitch@mandriva.org> 1.1.0.5-1mdv2008.1
+ Revision: 163038
- new version
  rediff config patch

* Sun Jan 27 2008 Guillaume Rousse <guillomovitch@mandriva.org> 1.1.0.4-1mdv2008.1
+ Revision: 158641
- update to new version 1.1.0.4

  + Thierry Vignaud <tvignaud@mandriva.com>
    - drop old menu

* Sun Jan 06 2008 Funda Wang <fwang@mandriva.org> 1.1.0.3-1mdv2008.1
+ Revision: 145962
- New version 1.1.0.3
- rediff patch0

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

  + Thierry Vignaud <tvignaud@mandriva.com>
    - kill re-definition of %%buildroot on Pixel's request

* Thu Oct 11 2007 Oden Eriksson <oeriksson@mandriva.com> 1.0.2-2mdv2008.1
+ Revision: 96997
- drop the quotes in the Exec= line (blino)

* Tue Jul 24 2007 Oden Eriksson <oeriksson@mandriva.com> 1.0.2-1mdv2008.0
+ Revision: 54974
- 1.0.2
- fix deps
- added apache access restrictions to 127.0.0.1 only


* Fri Mar 16 2007 Oden Eriksson <oeriksson@mandriva.com> 1.0.1-3mdv2007.1
+ Revision: 145081
- fix xdg menu
- adjust the patch

  + Jérôme Soyer <saispo@mandriva.org>
    - Add Obsoletes and Conflicts
    - Lowercase

* Sun Feb 18 2007 Nicolas Lécureuil <neoclust@mandriva.org> 1.0.1-1mdv2007.1
+ Revision: 122573
- Fix typo found by berthy

  + Jérôme Soyer <saispo@mandriva.org>
    - Import phpLDAPAdmin

